#!/usr/bin/env perl
## 
## Copyright (C) 2011-2018 The Regents of the University of California.
## 
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
## 
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
## 
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
## 

# Usage:  rm-conflicts.pl <dirty.sets >clean.sets
# Remove conflicting sets from the results of set-analysis

use strict;

my $col = undef;
my $n_conflicts = 0;
my $n_sets = 0;
my $skip = 0;

while (<>) {
    if (!defined $col) {
	if (!/^#/) { die "error: missing header\n"; }
	my @F = split;
	for (my $i = 0; $i < scalar @F; $i++) {
	    if (@F[$i] eq 'unsh>0') {
		$col = $i;
		print STDERR "unsh>0 in column $col\n";
		last;
	    }
	}
    } else {
	if (/^# set /) {
	    my @F = split;
	    if ($F[$col+1] > 0) {
		$skip = 1;
		$n_conflicts++;
		next;
	    }
	    $n_sets++;
	    $skip = 0;
	} elsif ($skip || /^UNSHARED/) {
	    next;
	}
    }
    print;
}

print STDERR "found $n_sets good sets, $n_conflicts conflicting sets\n";
